##############################################################################
package XML::ESDOM_1_1::Attr;
##############################################################################
use utf8;
use strict;
use XML::ESDOM_1_1::Node;
our @ISA = qw ( XML::ESDOM_1_1::Node );
our ( $__nodeName,
	$__nodeValue,
	$__nodeType,
	$__parentNode,
	$__childNodes,
	$__attributes,
	$__canHaveChild
	) = (
	$XML::ESDOM_1_1::Node::__nodeName,
	$XML::ESDOM_1_1::Node::__nodeValue,
	$XML::ESDOM_1_1::Node::__nodeType,
	$XML::ESDOM_1_1::Node::__parentNode,
	$XML::ESDOM_1_1::Node::__childNodes,
	$XML::ESDOM_1_1::Node::__attributes,
	$XML::ESDOM_1_1::Node::__canHaveChild
	);

sub new {
	my $class = shift;
	my $attrName = shift;
	unless( $attrName ) {return;}
	my $self = new XML::ESDOM_1_1::Node( $attrName );

	$self->[$__nodeType] = XML::ESDOM_1_1::Node::ATTRIBUTE_NODE;

	bless $self;
}

sub cloneNode {
	my $self = shift;
	my $deep = shift;
	my $clone;

	$clone = new XML::ESDOM_1_1::Attr( $self->nodeName );
	$clone->nodeValue = $self->nodeValue;
	if( $self->attributes ) {
		for( my $i = 0; $i < $self->attributes->length; $i++ ) {
			$clone->attributes->setNamedItem( $self->attributes->item($i)->cloneNode( 0 ) );
		}
	}
	if( $deep ) {
		for( my $i = 0; $i < $self->childNodes->length; $i++ ) {
			$clone->appendChild( $self->childNodes->item($i)->cloneNode( 1 ) );
		}
	}
	$clone;
}

1;

