package XML::ESDOM_1_1::NamedNodeMap;
use strict;
use XML::ESDOM_1_1::Node;

our $VERSION = "1.00";

our ( $__nodes, $__namemap ) = ( 0, 1 );

sub new {
	my ( $class ) = @_;
	my $self = bless [], $class;

	$self->[$__nodes] = [];
	$self->[$__namemap] = {};
	$self;
}

sub length {
	$#{$_[0]->[$__nodes]} +1;
}

sub getNamedItem {
	my $self = shift;
	my $name = shift;
	unless( defined( $self->[$__namemap]{$name} ) ) {
		return;
	}
	$self->[$__nodes][$self->[$__namemap]{$name}];
}

sub setNamedItem {
	my $self = shift;
	my $node = shift;
	my $name = $node->nodeName;
	unless( defined ( $self->[$__namemap]{$name} ) ) {
		$self->[$__namemap]{$name} = $self->length;
		push ( @{$self->[$__nodes]}, $node );
		return;
	} else {
		my $old = $self->[$__nodes][$self->[$__namemap]{$name}];
		$self->[$__nodes][$self->[$__namemap]{$name}] = $node;
		return $old;
	}
}

sub removeNamedItem {
	my $self = shift;
	my $name = shift;
	unless( defined ( $self->[$__namemap]{$name} ) ) {
		return;
	}
	my $index = $self->[$__namemap]{$name};
	my $old = $self->[$__nodes][$index];
	splice( @{$self->[$__nodes]}, $index, 1 );
	delete $self->[$__namemap]{$name};
	for( my $i = $index; $i < $self->length; $i++ ) {
		$self->[$__namemap]{$self->[$__nodes][$i]->nodeName} = $i;
	}
}

sub item {
	$_[0]->[$__nodes][$_[1]];
}

1;