package XML::ESDOM_1_1::NodeList;
use strict;

our $VERSION = "1.00";

sub new {
	bless [], $_[0];
}

sub item {
    $_[0]->[$_[1]];
}

sub length {
    $#{$_[0]} +1;
}

#########################################
# non DOM Interfaces

sub _insertNode {
	my $self = shift;
	my ( $newNode, $refNode ) = @_;
	return if( !$refNode || !$newNode );
	for( my $i = 0; $i < $self->length; $i++ ) {
		if( $self->[$i] eq $refNode ) {
			splice( @{$self}, $i, 1, $newNode, $refNode );
			return $newNode;
		}
	}
}

sub _addNode {
	my $self = shift;
	my $newNode = shift;
	if( $newNode ) {
		push ( @{$self}, $newNode );
	}
	$newNode;
}

sub _removeNode {
	my $self = shift;
	my $node = shift;
	return unless( $node );
	for( my $i = 0; $i < $self->length; $i++ ) {
		if( $self->[$i] eq $node ) {
			splice( @{$self}, $i, 1 );
			return $node;
		}
	}
}

sub _replaceNode {
	my $self = shift;
	my ( $newNode, $oldNode ) = @_;
	return if( !$oldNode || !$newNode );
	for( my $i = 0; $i < $self->length; $i++ ) {
		if( $self->[$i] eq $oldNode ) {
			$self->[$i] = $newNode;
			return $oldNode;
		}
	}
}

1;