#
#
use strict;
use File::Path;
use File::Basename;
my $install_dir = "";

foreach( @INC ) {
    if( /site/io ) {
		$install_dir = $_;
		last;
    }
}

unless ($install_dir) {
    die "'site/lib' folder not found!\n";
}

my @files = qw(
	       XML/ESDOM_1_1.pm
	       XML/ESDOM_1_1/Attr.pm
	       XML/ESDOM_1_1/CDATASection.pm
	       XML/ESDOM_1_1/Comment.pm
	       XML/ESDOM_1_1/Document.pm
	       XML/ESDOM_1_1/DocumentType.pm
	       XML/ESDOM_1_1/Element.pm
	       XML/ESDOM_1_1/NamedNodeMap.pm
	       XML/ESDOM_1_1/Node.pm
	       XML/ESDOM_1_1/NodeList.pm
	       XML/ESDOM_1_1/ProcessingInstruction.pm
	       XML/ESDOM_1_1/Text.pm
	       );

foreach my $file ( @files ) {
    open SRC, $file or die "$file:$!";
    my $buffer;

    my $dst = $install_dir . "/" . $file;

    my $dir = dirname($dst);
    mkpath([$dir], 0755, 1) or die "$dir:$!" unless -d $dir;
    open DST, ">$dst" or die "$dst:$!";

    while(read SRC, $buffer, 32768) {
		print DST $buffer;
    }

    close SRC; close DST;

}

warn "All scripts are installed successfully\n";
